<?php

class ButtonBrokenImageBox extends BrokenImgBox {
  var $_field_name;
  var $_field_value;
  var $_action_url;

  function ButtonBrokenImageBox($width, $height, $alt, $field, $value) {
    $this->BrokenImgBox($width, $height, $alt);

    global $g_css_handlers;
    $handler =& get_css_handler('-html2ps-form-action');
    $this->_action_url = $handler->get();

    $this->_field_name  = $field;
    $this->_field_value = $value;
  }

  function show(&$driver) {
    $status = parent::show($driver);

    global $g_config;
    if ($g_config['renderforms']) {
      $driver->field_pushbuttonimage($this->get_left_padding(),
                                     $this->get_top_padding(),
                                     $this->get_width()  + $this->get_padding_left() + $this->get_padding_right(),
                                     $this->get_height() + $this->get_padding_top()  + $this->get_padding_bottom(),
                                     $this->_field_name,
                                     $this->_field_value,
                                     $this->_action_url);
    };

    return $status;
  }
}

class ButtonImageBox extends ImgBox {
  var $_field_name;
  var $_field_value;
  var $_action_url;

  function ButtonImageBox($img, $field, $value) {
    $this->ImgBox($img);

    global $g_css_handlers;
    $handler =& get_css_handler('-html2ps-form-action');
    $this->_action_url = $handler->get();

    $this->_field_name  = $field;
    $this->_field_value = $value;
  }

  function show(&$driver) {
    $status = parent::show($driver);

    global $g_config;
    if ($g_config['renderforms']) {
      $driver->field_pushbuttonimage($this->get_left_padding(),
                                     $this->get_top_padding(),
                                     $this->get_width()  + $this->get_padding_left() + $this->get_padding_right(),
                                     $this->get_height() + $this->get_padding_top()  + $this->get_padding_bottom(),
                                     $this->_field_name,
                                     $this->_field_value,
                                     $this->_action_url);
    };

    return $status;
  }

  function &create(&$root, &$pipeline) {
    $name  = $root->get_attribute('name');
    $value = $root->get_attribute('value');

    $src = trim($root->get_attribute("src"));

    $src_img = Image::get($pipeline->guess_url($src), $pipeline);
    if (is_null($src_img)) {
      error_log(sprintf("Cannot open image at '%s'", $src));

      if ($root->has_attribute('width')) {
        $width = px2pt($root->get_attribute('width'));
      } else {
        $width = px2pt(BROKEN_IMAGE_DEFAULT_SIZE_PX);
      };

      if ($root->has_attribute('height')) {
        $height = px2pt($root->get_attribute('height'));
      } else {
        $height = px2pt(BROKEN_IMAGE_DEFAULT_SIZE_PX);
      };

      $alt = $root->get_attribute('alt');

      $box = new ButtonBrokenImagebox($width, $height, $alt, $name, $value);
      return $box;
    };

    $box = new ButtonImageBox($src_img, $name, $value);

    // Proportional scaling
    if ($root->has_attribute('width') && !$root->has_attribute('height')) {
      $box->scale = SCALE_WIDTH;

      // Only 'width' attribute given
      $size =
        $box->src_width/$box->src_height*
        $box->get_width();

      $box->put_height($size);

      // Update baseline according to constrained image height
      $box->default_baseline = $box->get_height();

    } elseif (!$root->has_attribute('width') && $root->has_attribute('height')) {
      $box->scale = SCALE_HEIGHT;

      // Only 'height' attribute given
      $size =
        $box->src_height/$box->src_width*
        $box->get_height();

      $box->put_width($size);
      $box->put_width_constraint(new WCConstant($size));

      $box->default_baseline = $box->get_height();
    };

    return $box;
  }
}

?>